
package de.ivu.elect.presentation.wahlvorschlag;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.wahlvorschlag.boundary.ListenverbindungBoundaryCreate;
import de.ivu.elect.business.wahlvorschlag.entity.Listenverbindung;
import de.ivu.elect.business.wahlvorschlag.entity.ListenverbindungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractListenverbindungCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractListenverbindungCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.LISTENVERBINDUNG_CREATE)
public abstract class AbstractListenverbindungCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<Listenverbindung> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "listenverbindungCreateView";

  public static final String VIEW_ID = "/wahlvorschlag/listenverbindung-create.xhtml";

  public static final String PARENT_VIEW_ID = "/wahlvorschlag/listenverbindung-search.xhtml";

  @Inject
  protected transient ListenverbindungBoundaryCreate create;

  protected Listenverbindung entity;

  @Inject
  protected transient ListenverbindungMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  Listenverbindung());
  }

  

  public Listenverbindung getEntity() {
    return entity;
  }

  protected void setEntity(Listenverbindung entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.LISTENVERBINDUNG_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Listenverbindung entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(Listenverbindung entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.LISTENVERBINDUNG_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
